Ruby: pm_array_pattern_node Struct Reference

Ruby 3.4.9p82 (2026-03-11 revision 76cca827ab52ab1d346a728f068d5b8da3e2952b)

Data Fields
pm_array_pattern_node Struct Reference

ArrayPatternNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | constant
| ArrayPatternNode#constant.
struct pm_node_list | requireds
| ArrayPatternNode#requireds.
struct pm_node * | rest
| ArrayPatternNode#rest.
struct pm_node_list | posts
| ArrayPatternNode#posts.
pm_location_t | opening_loc
| ArrayPatternNode#opening_loc.
pm_location_t | closing_loc
| ArrayPatternNode#closing_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ArrayPatternNode.

Represents an array pattern in pattern matching.

    foo in 1, 2
    ^^^^^^^^^^^

    foo in [1, 2]
    ^^^^^^^^^^^^^

    foo in *bar
    ^^^^^^^^^^^

    foo in Bar[]
    ^^^^^^^^^^^^

    foo in Bar[1, 2, 3]
    ^^^^^^^^^^^^^^^^^^^

Type: ::PM_ARRAY_PATTERN_NODE

Definition at line 1415 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_array_pattern_node::base

The embedded base node.

Definition at line 1417 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_array_pattern_node::closing_loc

ArrayPatternNode#closing_loc.

Represents the closing location of the array pattern.

    foo in [1, 2]
                ^

Definition at line 1484 of file ast.h.

Referenced by pm_dump_json().

## ◆ constant

struct pm_node* pm_array_pattern_node::constant

ArrayPatternNode#constant.

Represents the optional constant preceding the Array

    foo in Bar[]
           ^^^

    foo in Bar[1, 2, 3]
           ^^^

    foo in Bar::Baz[1, 2, 3]
           ^^^^^^^^

Definition at line 1434 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ opening_loc

pm_location_t pm_array_pattern_node::opening_loc

ArrayPatternNode#opening_loc.

Represents the opening location of the array pattern.

    foo in [1, 2]
           ^

Definition at line 1474 of file ast.h.

Referenced by pm_dump_json().

## ◆ posts

struct pm_node_list pm_array_pattern_node::posts

ArrayPatternNode#posts.

Represents the elements after the rest element of the array pattern.

    foo in *bar, baz
                 ^^^

Definition at line 1464 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ requireds

struct pm_node_list pm_array_pattern_node::requireds

ArrayPatternNode#requireds.

Represents the required elements of the array pattern.

    foo in [1, 2]
            ^  ^

Definition at line 1444 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ rest

struct pm_node* pm_array_pattern_node::rest

ArrayPatternNode#rest.

Represents the rest element of the array pattern.

    foo in *bar
           ^^^^

Definition at line 1454 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h